﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ArrayCovariance {
	class Program {
		static void Main(string[] args) {
			try {
				string[] sa = new string[10];
				sa[0] = "Hi";

				// are covariant => OK
				object[] oa = sa;
				object o = oa[0];   // read = OK







				




								
				oa[0] = "Hello";	
				oa[1] = 1;			// write = Run-time error

				oa = new object[10];
				oa[0] = 1;
				
				// Compile error <= not contravariant
				// sa = oa;
				sa[1] = "Ahoy";		// write = OK
				string s = sa[0];	// read = problem ([0] contains boxed int 1)				

			} catch (Exception ex) {
				Console.WriteLine(ex);
			}
		}
	}
}
